#include "WorkingTreeFile.h"
#include <stdio.h>
#include <conio.h>

int MyTreeCalculation();

int main()
{   FILE *TreeFile;
    
    TreeFile=fopen("Tree1.tre","r");
    if(TreeFile==NULL)
    {   printf("please run program \"Trees\"\nPress any key ...");
        getch();
        return 1;
    }
    fclose(TreeFile);
    
    ROOT=OpenTreeFile(L"Tree1.tre",&Setting);
    Setting>>=11;
    if(ROOT && 3<=Setting)  /*  tree of strings  */
    {   printf("\nError: tree of strings.\nPress any key ...");
        getch();
        DelTree();
        return 1;
    }
       
    if(ROOT)
    {   MyTreeCalculation();
        DelTree();
    }
    return 0;
}

/******************** no scan Tree ***************************/

int MyTreeCalculation()
{   long MaxWeight=0,MinWeight=0,CurrentWeight=0;
    int  CurrentLength=0;
    char CurrentWay[200],MaxWay[200],MinWay[200],M[2000];
    struct TREE *Z;

    Z=ROOT;
    Z->Father=NULL;
    while(Z)
    {   if(Z->ws==NULL) CurrentWeight+=Z->n;
        if(Z->Left && (Z->ws==NULL || *(Z->ws)==L'2'))
        {   if(Z->ws) *(Z->ws)=L'3';
            else
            {   Z->ws=(WCHAR *)GlobalAlloc(GMEM_ZEROINIT,2);
                *(Z->ws)=L'1';
            }
            CurrentWay[CurrentLength++]='L';
            Z=Z->Left;
        }
        else if(Z->Right && (Z->ws==NULL || *(Z->ws)==L'1'))
        {   if(Z->ws) *(Z->ws)=L'3';
            else
            {   Z->ws=(WCHAR *)GlobalAlloc(GMEM_ZEROINIT,2);
                *(Z->ws)=L'2';
            }
            CurrentWay[CurrentLength++]='R';
            Z=Z->Right;
        }
        else 
        {   if(Z->Left==NULL && Z->Right==NULL)
            {   CurrentWay[CurrentLength]=0;
                if(MaxWeight<CurrentWeight)
                {   MaxWeight=CurrentWeight;
                    lstrcpy(MaxWay,CurrentWay);
                }
                if(CurrentWeight<MinWeight || MinWeight==0)
                {   MinWeight=CurrentWeight;
                    lstrcpy(MinWay,CurrentWay);
                }
            } 
            if(CurrentLength) --CurrentLength;
            CurrentWeight-=Z->n;
            Z=Z->Father;
        }
    }
    wsprintf(M,"Max Weight=%d, Way=%s.\r\nMin Weight=%d, Way=%s.\n",MaxWeight,MaxWay,MinWeight,MinWay);
    ResultFile(M,0);
    return 0;     
}
