#include "WorkingTreeFile.h"
#include <stdio.h>
#include <conio.h>

/*********** my function **********************/
void MyPreorder(struct TREE *, WCHAR *);
void MyInorder(struct TREE *, WCHAR *);
void MyPostorder(struct TREE *, WCHAR *);
/**********************************************/

int main()
{   int j;
    WCHAR M[4000];
        
    ROOT=(struct TREE *)OpenTreeFile(L"Tree1.tre",&Setting);
    Setting>>=11;
    j=0;
    printf("\nProgram working:");
    while(j!='1' && j!='2' && j!='3')
    {   printf("\n\nPreorder - 1\nInorder - 2\nPostorder - 3\n\nPlease, enter number:\n\n");
        j=getche();
    }
    if(j=='1') MyPreorder(ROOT,M);
    if(j=='2') MyInorder(ROOT,M);
    if(j=='3') MyPostorder(ROOT,M);

    ResultFileW(M);
    DelTree();
    return 0;
}

/******************** my function *****************************/

void MyPreorder(struct TREE *X, WCHAR *M)
{   int m=0;
    WCHAR UUU[40];
    
    wsprintfW(M,L"Preorder\r\n");
    while(1)
    {   if(m==0)
        {   wsprintfW(UUU,L"\r\n");
            lstrcatW(M,UUU);
            if(3<=Setting) lstrcatW(M,X->ws);
            else
            {   wsprintfW(UUU,L"%d",X->n);
                lstrcatW(M,UUU);
            }
        }
        if(X->Left && m==0) X=X->Left;
        else if(X->Right && m!=2)
        {   X=X->Right;
            m=0;
        }
        else
        {   if(X->Father)  
            {   if((X->Father)->Left==X)
                {   X=X->Father;
                    m=1;
                }
                else
                {   X=X->Father;    
                    m=2;
                }
            }
            else break;
        }
    }
}

void MyInorder(struct TREE *X, WCHAR *M)
{   int m=0;
    WCHAR UUU[40];

    wsprintfW(M,L"Inorder\r\n");
    while(1)
    {   if(m==1 || (X->Left==NULL && m==0))
        {   wsprintfW(UUU,L"\r\n");
            lstrcatW(M,UUU);
            if(3<=Setting) lstrcatW(M,X->ws);
            else
            {   wsprintfW(UUU,L"%d",X->n);
                lstrcatW(M,UUU);
            }
        }
        if(X->Left && m==0) X=X->Left;
        else if(X->Right && m!=2)
        {   X=X->Right;
            m=0;
        }
        else
        {   if(X->Father)   
            {   if((X->Father)->Left==X)
                {   X=X->Father;
                    m=1;
                }
                else
                {   X=X->Father;    
                    m=2;
                }
            }
            else break;
        }
    }
}

void MyPostorder(struct TREE *X, WCHAR *M)
{   int m=0;
    WCHAR UUU[40];

    wsprintfW(M,L"Postorder\r\n");
    while(1)
    {   if(m==2 || (X->Right==NULL && (X->Left==NULL || m==1)))
        {   wsprintfW(UUU,L"\r\n");
            lstrcatW(M,UUU);
            if(3<=Setting) lstrcatW(M,X->ws);
            else
            {   wsprintfW(UUU,L"%d",X->n);
                lstrcatW(M,UUU);
            }
        }
        if(X->Left && m==0) X=X->Left;
        else if(X->Right && m!=2)
        {   X=X->Right;
            m=0;
        }
        else
        {   if(X->Father)   
            {   if((X->Father)->Left==X)
                {   X=X->Father;
                    m=1;
                }
                else
                {   X=X->Father;    
                    m=2;
                }
            }
            else break;
        }
    }
}

