#include <windows.h>
#define EXPORT __declspec(dllexport)

struct TREE
{   int n;
    WCHAR *ws;
    struct TREE *Father;
    struct TREE *Left;
    struct TREE *Right;
} *ROOT;
short Setting;

EXPORT void *CALLBACK OpenTreeFile(WCHAR *, short *);
/*    "Tree1.tre"       .
   the function reads the file "Tree1.tre" and creates a binary tree in your program. */

EXPORT void CALLBACK ResultFile(char *, short);
/* short=0 - Eng
   short=1 - Heb
   short=2 - Rus
         "Result.txt".
   ascii-   unicode-.
   the function records your results in the file "Result.txt".
 The ascii text is converted to unicode text.  */

EXPORT void CALLBACK ResultFileW(WCHAR *);
/*       "Result.txt".
   the function records your results in the file "Result.txt". */

EXPORT void CALLBACK DelTree();
/*   ,   .
   releasing memory occupied by a binary tree   */    

EXPORT void CALLBACK UpdateTree(struct TREE *, short);
/*     "Tree2.tre"  
        .
   the function writes to the file "Tree2.tre" a binary tree
 after its change in your program.
   short=0,1,2,3,4,   0 - wihtout modification tree type.
   short=1 - sorting tree of numbers,
   short=2 - general tree of numbers,
   short=3 - sorting tree of strings,
   short=4 - general tree of strings.  */
