#include "WorkingTreeFile.h"
#include <stdio.h>
#include <string.h>

void MyTreeScanning(struct TREE *);
int LeftSon,RightSon,Nodes,LastNode;
char M[2000];

int main()
{   short leng; /*  Eng - 0,  Heb - 1,  Rus - 2  */
    
    ROOT=OpenTreeFile(L"Tree1.tre", &Setting);
    if(ROOT)
    {   Nodes=LeftSon=RightSon=LastNode=0;
        MyTreeScanning(ROOT);
        DelTree();
    }

/********** English data preparation ****************/
    leng=0;
    sprintf(M,"Left daughter nodes number - %d,\r\nright daughter nodes number - %d.\r\n",LeftSon,RightSon);
	if(LeftSon<RightSon) strcat(M,"Efraim tree.\r\n");
    if(RightSon<LeftSon) strcat(M,"Menashe tree.\r\n");
    sprintf(M+strlen(M),"\r\nNodes number - %d, terminal nodes number - %d.",Nodes,LastNode);
	if((Nodes+1)/2<=LastNode) strcat(M,"\r\nFlat tree.");
/*********** Hebrew data preparation ******************/  
/*  leng=1;
    sprintf(M+strlen(M),".%d -  \r\n",Nodes);
    sprintf(M+strlen(M),".%d -  \r\n",LastNode);
    sprintf(M+strlen(M),".%d -   \r\n",LeftSon);
    sprintf(M+strlen(M),".%d -   ",RightSon);
    if(LeftSon<RightSon) strcat(M,"\r\n. ");
    if(RightSon<LeftSon) strcat(M,"\r\n. ");
    if((Nodes+1)/2<=LastNode) strcat(M,". ");    */
/********** Russian data preparation ******************/ 
/*  leng=2;
    sprintf(M,"   - %d,    - %d.\r\n",LeftSon,RightSon);
    if(LeftSon<RightSon) strcat(M," .\r\n");
    if(RightSon<LeftSon) strcat(M," .\r\n");
    sprintf(M+strlen(M),"\r\n  - %d,   - %d.",Nodes,LastNode);
    if((Nodes+1)/2<=LastNode) strcat(M,"\r\n .");  */

/******** show results ***********/
	ResultFile(M,leng);
/*********************************/
    return 0;
}

/********************* scan Tree *************************/

void MyTreeScanning(struct TREE *Z)
{   ++Nodes;
    if(Z->Left)
    {   ++LeftSon;
        MyTreeScanning(Z->Left);
    }
    if(Z->Right)
    {   ++RightSon;
        MyTreeScanning(Z->Right);
    }
    if(Z->Left==NULL && Z->Right==NULL) ++LastNode;
} 
/*********************** End *****************************/
